"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactKonva = require("react-konva");

var _canvas = require("../../utils/canvas");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var HighlightShape = function HighlightShape(_ref) {
  var width = _ref.width,
      height = _ref.height,
      masks = _ref.masks,
      currentMask = _ref.currentMask;
  return _react["default"].createElement(_reactKonva.Shape, {
    x: 0,
    y: 0,
    width: width,
    height: height,
    sceneFunc: function sceneFunc(ctx, shape) {
      ctx.beginPath();
      ctx.moveTo(0, 0);
      ctx.lineTo(width, 0);
      ctx.lineTo(width, height);
      ctx.lineTo(0, height);
      ctx.lineTo(0, 0);
      ctx.closePath();
      masks.forEach(function (maskPoints) {
        var startPoint = maskPoints[0];
        ctx.moveTo(startPoint[0], startPoint[1]);
        maskPoints.forEach(function (point) {
          ctx.lineTo(point[0], point[1]);
        });
        ctx.closePath();
      });

      if (currentMask.startX != -1 && currentMask.endX !== -1) {
        ctx.moveTo(currentMask.startX, currentMask.startY);
        ctx.lineTo(currentMask.startX, currentMask.endY);
        ctx.lineTo(currentMask.endX, currentMask.endY);
        ctx.lineTo(currentMask.endX, currentMask.startY);
        ctx.lineTo(currentMask.startX, currentMask.startY);
        ctx.closePath();
      }

      ctx.fillStyle = 'rgba(0,0,0,0.3)';
      ctx.strokeStyle = 'rgba(0.5,0.5,0.5,0.5)';
      ctx.lineWidth = 1;
      ctx.fill();
      ctx.stroke();
    }
  });
};

var FeedbackDrawer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FeedbackDrawer, _React$Component);

  function FeedbackDrawer(props) {
    var _this;

    _classCallCheck(this, FeedbackDrawer);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FeedbackDrawer).call(this, props));
    _this.state = {
      isDrawing: false,
      highlightMasks: [// [[100, 100], [100, 400], [200, 400], [200, 100], [100, 100]]
      ],
      currentStartX: -1,
      currentStartY: -1,
      currentEndX: -1,
      currentEndY: -1
    };
    _this.onMouseDown = _this.onMouseDown.bind(_assertThisInitialized(_this));
    _this.onMouseUp = _this.onMouseUp.bind(_assertThisInitialized(_this));
    _this.onMouseMove = _this.onMouseMove.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(FeedbackDrawer, [{
    key: "onMouseDown",
    value: function onMouseDown(event) {
      if (this.props.isCanvasActive && !this.state.isDrawing) {
        // this should be triggerd via onMouseMove when currentStartX - event.evt.offsetX > 20
        this.setState({
          isDrawing: true,
          currentStartX: event.evt.offsetX,
          currentStartY: event.evt.offsetY
        });
      }
    }
  }, {
    key: "onMouseUp",
    value: function onMouseUp(event) {
      if (this.props.isCanvasActive && this.state.isDrawing) {
        this.setState(function (prevState) {
          var highlightMasks = prevState.highlightMasks,
              currentStartX = prevState.currentStartX,
              currentStartY = prevState.currentStartY;
          var startX = currentStartX >= event.evt.offsetX ? currentStartX : event.evt.offsetX;
          var startY = currentStartY >= event.evt.offsetY ? currentStartY : event.evt.offsetY;
          var endX = currentStartX < event.evt.offsetX ? currentStartX : event.evt.offsetX;
          var endY = currentStartY < event.evt.offsetY ? currentStartY : event.evt.offsetY;
          var newHighlightMask = [[startX, startY], [startX, endY], [endX, endY], [endX, startY], [startX, startY]];
          var newHighlightMasks = (0, _canvas.includeNewMask)({
            highlightMasks: highlightMasks,
            newHighlightMask: newHighlightMask
          });
          return {
            isDrawing: false,
            currentStartX: -1,
            currentStartY: -1,
            currentEndX: -1,
            currentEndY: -1,
            highlightMasks: newHighlightMasks
          };
        });
      }
    }
  }, {
    key: "onMouseMove",
    value: function onMouseMove(event) {
      if (this.props.isCanvasActive && this.state.isDrawing) {
        this.setState({
          currentEndX: event.evt.offsetX,
          currentEndY: event.evt.offsetY
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var width = document.body.scrollWidth;
      var height = document.body.scrollHeight;
      var _this$state = this.state,
          highlightMasks = _this$state.highlightMasks,
          currentStartX = _this$state.currentStartX,
          currentStartY = _this$state.currentStartY,
          currentEndX = _this$state.currentEndX,
          currentEndY = _this$state.currentEndY;
      return _react["default"].createElement(_reactKonva.Stage, {
        style: {
          position: 'fixed',
          top: 0,
          left: 0,
          zIndex: 1
        },
        width: width,
        height: height
      }, _react["default"].createElement(_reactKonva.Layer, null, _react["default"].createElement(_reactKonva.Group, null, _react["default"].createElement(HighlightShape, {
        masks: highlightMasks,
        currentMask: {
          startX: currentStartX,
          startY: currentStartY,
          endX: currentEndX,
          endY: currentEndY
        },
        width: width,
        height: height
      }), _react["default"].createElement(_reactKonva.Rect, {
        id: "fake-background",
        x: 0,
        y: 0,
        width: width,
        height: height,
        onMouseDown: this.onMouseDown,
        onMouseUp: this.onMouseUp,
        onMouseMove: this.onMouseMove
      }))));
    }
  }]);

  return FeedbackDrawer;
}(_react["default"].Component);

var _default = FeedbackDrawer;
exports["default"] = _default;