"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _menu = _interopRequireDefault(require("./menu"));

var _modal = _interopRequireDefault(require("./modal"));

var _canvas = _interopRequireDefault(require("./canvas"));

var _mail = _interopRequireDefault(require("../utils/mail"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Index =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Index, _React$Component);

  function Index(props) {
    var _this;

    _classCallCheck(this, Index);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Index).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "takeScreenshot", function () {
      // Generate canvas from html
      _this.html2canvas(document.body).then(function (canvas) {
        // // Generate blob from canvas
        // canvas.toBlob(blob => {
        //   // Generate file download
        //   saveAs(blob, 'tmp_screenshot.png');
        //   // todo send this to backend
        // });
        // // Generate base64 from canvas
        var jpegUrl = canvas.toDataURL('image/jpeg');
        var screenshotPngUrl = canvas.toDataURL();

        _this.setState({
          screenshotPngUrl: screenshotPngUrl
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "editScreenshot", function (_ref) {
      var description = _ref.description;

      _this.setState({
        description: description,
        isCanvasVisible: true,
        isCanvasActive: true,
        isFeedbackDialogVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onDone", function () {
      var screenshotPngUrl = _this.takeScreenshot();

      _this.setState({
        screenshotPngUrl: screenshotPngUrl,
        isCanvasActive: false,
        isFeedbackDialogVisible: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onCancel", function () {
      _this.setState({
        isFeedbackDialogVisible: false,
        isCanvasActive: false,
        isCanvasVisible: false,
        description: '',
        screenshotPngUrl: null
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onOk", function () {
      var _this$props$config = _this.props.config,
          EMAIL_SMTP_HOST = _this$props$config.EMAIL_SMTP_HOST,
          EMAIL_TO = _this$props$config.EMAIL_TO,
          EMAIL_USER = _this$props$config.EMAIL_USER,
          EMAIL_PASSWORD = _this$props$config.EMAIL_PASSWORD;
      var form = _this.formRef.props.form;
      form.validateFields(function (err, formValues) {
        if (err) {
          return;
        }

        var description = formValues.description;
        var data = {
          screenshotPngUrl: _this.state.screenshotPngUrl,
          description: description,
          url: window.location.pathname + window.location.search,
          timestamp: new Date().toUTCString(),
          system: {
            cookieEnabled: navigator.cookieEnabled,
            userAgent: navigator.userAgent,
            appVersion: navigator.appVersion,
            language: navigator.language,
            languages: navigator.languages
          }
        };

        _mail["default"].send({
          Host: EMAIL_SMTP_HOST,
          Username: EMAIL_USER,
          Password: EMAIL_PASSWORD,
          To: EMAIL_TO,
          From: 'Fedback@wenigerpendeln.de',
          Subject: 'New feedback submitted',
          Body: JSON.stringify(data)
        }).then(function () {
          return _antd.message.success('Vielen Dank! Dein Feedback wurde erfolgreich übermittelt.');
        });

        form.resetFields();

        _this.setState({
          description: '',
          screenshotPngUrl: null,
          isCanvasVisible: false,
          isCanvasActive: false,
          isFeedbackDialogVisible: false
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveFormRef", function (formRef) {
      _this.formRef = formRef;
    });

    _this.state = {
      description: '',
      screenshotPngUrl: null,
      isCanvasVisible: false,
      isCanvasActive: false,
      isFeedbackDialogVisible: false
    };
    _this.html2canvas;
    _this.onDone = _this.onDone.bind(_assertThisInitialized(_this));
    _this.onCancel = _this.onCancel.bind(_assertThisInitialized(_this));
    _this.onOk = _this.onOk.bind(_assertThisInitialized(_this));
    _this.editScreenshot = _this.editScreenshot.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Index, [{
    key: "componentDidMount",
    value: function () {
      var _componentDidMount = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return Promise.resolve().then(function () {
                  return _interopRequireWildcard(require('html2canvas'));
                });

              case 2:
                result = _context.sent;
                this.html2canvas = result["default"];
                document.body.style.overflow = 'hidden';

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _componentDidMount.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.body.style.overflow = null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          description = _this$state.description,
          isCanvasVisible = _this$state.isCanvasVisible,
          isCanvasActive = _this$state.isCanvasActive,
          isFeedbackDialogVisible = _this$state.isFeedbackDialogVisible,
          screenshotPngUrl = _this$state.screenshotPngUrl;
      return _react["default"].createElement("div", {
        style: {
          backgroundColor: 'transparent'
        }
      }, isCanvasVisible && _react["default"].createElement(_canvas["default"], {
        isCanvasActive: isCanvasActive
      }), isCanvasVisible && _react["default"].createElement(_menu["default"], {
        isCanvasActive: isCanvasActive,
        onDone: this.onDone
      }), isFeedbackDialogVisible && screenshotPngUrl === null && _react["default"].createElement("div", {
        style: {
          position: 'fixed',
          top: '50vh',
          textAlign: 'center',
          width: 50,
          height: 50,
          backgroundColor: 'rgb(255,255,255,0.3)'
        }
      }, _react["default"].createElement("div", {
        style: {}
      }, _react["default"].createElement(_antd.Spin, {
        size: "large"
      }))), isFeedbackDialogVisible && screenshotPngUrl !== null && _react["default"].createElement(_modal["default"], {
        wrappedComponentRef: this.saveFormRef,
        onCancel: this.onCancel,
        onOk: this.onOk,
        editScreenshot: this.editScreenshot,
        screenshotPngUrl: screenshotPngUrl,
        description: description
      }), _react["default"].createElement(_antd.Button, {
        style: {
          padding: 0
        },
        type: "link",
        onClick: function onClick() {
          return _this2.setState({
            isCanvasVisible: false,
            isCanvasActive: false,
            isFeedbackDialogVisible: false
          }, function () {
            _this2.takeScreenshot();

            _this2.setState({
              isCanvasVisible: true,
              isCanvasActive: false,
              isFeedbackDialogVisible: true
            });
          });
        }
      }, "Feedback geben"));
    }
  }]);

  return Index;
}(_react["default"].Component);

var _default = Index;
exports["default"] = _default;