"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CanvasMenu =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CanvasMenu, _React$Component);

  function CanvasMenu(props) {
    var _this;

    _classCallCheck(this, CanvasMenu);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CanvasMenu).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onMouseDown", function (event) {
      event.stopPropagation();
      event.preventDefault(); // only left mouse button

      if (event.button !== 0) return;

      _this.setState({
        dragging: true,
        rel: {
          x: event.pageX - _this.state.pos.x,
          y: event.pageY - _this.state.pos.y
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseUp", function (event) {
      event.stopPropagation();
      event.preventDefault();

      _this.setState({
        dragging: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseMove", function (event) {
      if (!_this.state.dragging) return;
      event.stopPropagation();
      event.preventDefault(); // only left mouse button

      if (event.button !== 0) return;

      _this.setState({
        pos: {
          x: event.pageX - _this.state.rel.x,
          y: event.pageY - _this.state.rel.y
        }
      });
    });

    _this.state = {
      dragging: false,
      pos: {
        x: 0,
        y: 0
      },
      rel: null
    };
    return _this;
  }

  _createClass(CanvasMenu, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var x = (document.body.clientWidth - 219.594) / 2;
      var y = (document.body.clientHeight - 64) / 2;
      this.setState({
        pos: {
          x: x,
          y: y
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isCanvasActive = _this$props.isCanvasActive,
          onDone = _this$props.onDone;
      var pos = this.state.pos;
      if (!isCanvasActive) return null;
      return _react["default"].createElement("div", {
        style: {
          display: 'block',
          position: 'fixed',
          top: pos.y,
          left: pos.x,
          background: 'white',
          paddingLeft: 8,
          paddingRight: 8,
          borderWidth: 1,
          borderStyle: 'solid',
          cursor: 'grab',
          zIndex: 10
        },
        onMouseDown: this.onMouseDown,
        onMouseUp: this.onMouseUp,
        onMouseMove: this.onMouseMove
      }, _react["default"].createElement("p", {
        style: {
          display: 'inline'
        }
      }, "Information markieren"), _react["default"].createElement(_antd.Button, {
        style: {
          display: 'inline',
          marginLeft: 8
        },
        type: "primary",
        onClick: onDone
      }, "Fertig"));
    }
  }]);

  return CanvasMenu;
}(_react["default"].Component);

var _default = CanvasMenu;
exports["default"] = _default;