"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _reactTextTruncate = _interopRequireDefault(require("react-text-truncate"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  .ant-modal-body {\n    padding: 16px;\n    padding-bottom: 12px;\n  }\n\n  @media (max-width: 375px) {\n    .ant-modal-content {\n      /* width: 100vw;\n      max-width: 100vw;\n      height: 100vh; */\n      border-radius: 0px;\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StyledModal = (0, _styledComponents["default"])(_antd.Modal)(_templateObject());

var FeedbackModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FeedbackModal, _React$Component);

  function FeedbackModal(props) {
    var _this;

    _classCallCheck(this, FeedbackModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FeedbackModal).call(this, props));
    _this.state = {
      textLines: 5
    };
    return _this;
  }

  _createClass(FeedbackModal, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          description = _this$props.description,
          onCancel = _this$props.onCancel,
          onOk = _this$props.onOk,
          editScreenshot = _this$props.editScreenshot,
          form = _this$props.form,
          screenshotPngUrl = _this$props.screenshotPngUrl;
      var getFieldDecorator = form.getFieldDecorator;
      var textLines = this.state.textLines;
      return _react["default"].createElement(StyledModal, {
        style: {
          margin: 0,
          width: '100vw',
          maxWidth: '350px'
        },
        title: "Feedback geben",
        width: '100vw',
        visible: true,
        centered: true,
        okText: "senden",
        cancelText: "abbrechen",
        onOk: onOk,
        onCancel: onCancel
      }, _react["default"].createElement(_antd.Form, {
        layout: "vertical",
        hideRequiredMark: true
      }, _react["default"].createElement(_antd.Form.Item, {
        style: {
          margin: 0
        }
      }, getFieldDecorator('description', {
        initialValue: description,
        rules: [{
          required: true,
          message: 'Eine Beschreibung ist erforderlich!'
        }]
      })(_react["default"].createElement(_antd.Input.TextArea, {
        rows: 3,
        placeholder: "Feedback beschreiben oder Ideen einbringen"
      })))), screenshotPngUrl && _react["default"].createElement("div", {
        style: {
          maxHeight: 200,
          display: 'inline-block',
          overflow: 'hidden',
          border: 1,
          borderColor: '#446aff',
          borderStyle: 'solid',
          borderRadius: 4
        }
      }, _react["default"].createElement("img", {
        src: screenshotPngUrl,
        alt: "Current view screenshot",
        width: "100%",
        style: {
          type: 'block',
          background: 'lightgrey',
          width: '100%',
          marginBottom: 8,
          opacity: 0.7,
          filter: 'alpha(opacity=40)'
        }
      })), _react["default"].createElement(_antd.Button, {
        style: {
          marginBottom: 8,
          width: '100%'
        },
        type: "primary",
        ghost: true,
        onClick: function onClick() {
          return editScreenshot({
            description: form.getFieldValue('description')
          });
        }
      }, "Screenshot bearbeiten"), _react["default"].createElement("div", null, _react["default"].createElement(_reactTextTruncate["default"], {
        line: textLines,
        truncateText: "\u2026",
        text: " Dein Feedback wird an den Betreiber dieser Seite gesendet. Wir erfassen zus\xE4tzlich zu den von Dir eingebrachten Angaben Systeminformationen (z.B. Browser, Betriebssystem, etc.) Mithilfe dieser Informationen k\xF6nnen wir unter Einhaltung unserer Datenschutzbestimmungen und Nutzungsbedingungen  technische Probleme l\xF6sen und unsere Dienste verbessern. ",
        textTruncateChild: _react["default"].createElement("a", {
          href: "#",
          onClick: function onClick() {
            return _this2.setState({
              textLines: 100
            });
          }
        }, "Alles zeigen")
      }), _react["default"].createElement("p", {
        style: {
          type: 'flex',
          margin: 0
        }
      })));
    }
  }]);

  return FeedbackModal;
}(_react["default"].Component);

var _default = _antd.Form.create({
  name: 'feedback_dialog'
})(FeedbackModal);

exports["default"] = _default;