"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.includeNewMask = exports.calcMasksIntersect = void 0;

var _polygonClipping = _interopRequireDefault(require("polygon-clipping"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var calcMasksIntersect = function calcMasksIntersect(_ref) {
  var mask1 = _ref.mask1,
      mask2 = _ref.mask2;
  return _polygonClipping["default"].intersection([mask1], [mask2]).length > 0;
};

exports.calcMasksIntersect = calcMasksIntersect;

var includeNewMask = function includeNewMask(_ref2) {
  var highlightMasks = _ref2.highlightMasks,
      newHighlightMask = _ref2.newHighlightMask;
  var isIntersection = false;

  var newHighlightMasks = _toConsumableArray(highlightMasks); // Detect & union intersecting polygons


  for (var i = 0; i < highlightMasks.length; i++) {
    var tmpMask = highlightMasks[i];
    isIntersection = calcMasksIntersect({
      mask1: tmpMask,
      mask2: newHighlightMask
    });

    if (isIntersection) {
      var points = _polygonClipping["default"].union([tmpMask], [newHighlightMask])[0]; // sort counter clow wise


      var ccwMask = points[0].reverse();
      newHighlightMasks[i] = ccwMask;
      break;
    }
  }

  if (!isIntersection) {
    newHighlightMasks = [].concat(_toConsumableArray(newHighlightMasks), [newHighlightMask]);
  }

  return newHighlightMasks;
};

exports.includeNewMask = includeNewMask;